'use strict';

var BoletimMedicaoClienteController = angular.module('BoletimMedicaoClienteController', []);

BoletimMedicaoClienteController.controller('BoletimMedicaoClienteCtrl', ['$scope', '$filter', 'Relatorio', 'CacheApp',
  ($scope, $filter, Relatorio, CacheApp) => {

    $scope.construcao = CacheApp.getConstrucao();

    // $scope.Opcoes = [
    //     {Id: 0, Descricao: 'Sem BDI e encargos'},
    //     {Id: 1, Descricao: 'Com BDI e sem encargos'},
    //     {Id: 2, Descricao: 'Sem BDI e com encargos'},
    //     {Id: 3, Descricao: 'Com BDI e Encargos'}
    // ];
    
    $scope.relatorio = {};
    $scope.relatorio.DataInicio = CacheApp.getData($scope.construcao.DataInicio ? $filter("date")($scope.construcao.DataInicio, 'yyyy-MM-ddT00:00:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z'));
    $scope.relatorio.DataFim = CacheApp.getData($scope.construcao.DataFim ? $filter("date")($scope.construcao.DataFim, 'yyyy-MM-ddT00:00:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z'));
    $scope.relatorio.OpcaoSelecionada = {Id: 3, Descricao: 'Com BDI e Encargos'};

    $scope.getBoletimMedicao = () => {
        
        $scope.boletimMedicao = {};
        $scope.relatorio.ValorTotal = 0;
        $scope.relatorio.AvancoTotal = 0;
        Relatorio.getBoletimMedicao($scope.relatorio.OpcaoSelecionada.Id, $scope.construcao.Id, $filter("date")($scope.relatorio.DataInicio, 'yyyy-MM-dd'), $filter("date")($scope.relatorio.DataFim, 'yyyy-MM-dd'),
            (data) => {
                $scope.boletimMedicao = data.Instance;
                for (var i in $scope.boletimMedicao.Etapas) {
                    $scope.boletimMedicao.Etapas[i].ValorTotal = 0;
                    $scope.boletimMedicao.Etapas[i].AvancoTotal = 0;
                    for (var j in $scope.boletimMedicao.Etapas[i].Itens) {
                        $scope.boletimMedicao.Etapas[i].ValorTotal += $scope.boletimMedicao.Etapas[i].Itens[j].ValorAvanco;
                        $scope.boletimMedicao.Etapas[i].AvancoTotal += $scope.boletimMedicao.Etapas[i].Itens[j].IncidenciaAvanco;
                    }
                    $scope.relatorio.ValorTotal += $scope.boletimMedicao.Etapas[i].ValorTotal;
                    $scope.relatorio.AvancoTotal += $scope.boletimMedicao.Etapas[i].AvancoTotal;
                }
            });
    }
    $scope.getBoletimMedicao();

    $scope.pdfBoletimMedicao = () => {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta,
            DataInicio: $filter("date")($scope.relatorio.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.relatorio.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda
        };

        Relatorio.pdfBoletimMedicao($scope.relatorio.OpcaoSelecionada.Id, $scope.construcao.Id, $filter("date")($scope.relatorio.DataInicio, 'yyyy-MM-dd'), $filter("date")($scope.relatorio.DataFim, 'yyyy-MM-dd'), cabecalho,
            (data) => {
                window.location.assign(data.Instance);
            });
    }

    $scope.xlsBoletimMedicao = () => {
    var cabecalho = {
        Avatar: $scope.construcao.ContaAvatar,
        Obra: $scope.construcao.Titulo,
        Conta: $scope.construcao.Conta,
        DataInicio: $filter("date")($scope.relatorio.DataInicio, 'dd/MM/yyyy'),
        DataFim: $filter("date")($scope.relatorio.DataFim, 'dd/MM/yyyy'),
        Moeda: $scope.construcao.Moeda
    };

    Relatorio.xlsBoletimMedicao($scope.relatorio.OpcaoSelecionada.Id, $scope.construcao.Id, $filter("date")($scope.relatorio.DataInicio, 'yyyy-MM-dd'), $filter("date")($scope.relatorio.DataFim, 'yyyy-MM-dd'), cabecalho,
        (data) => {
            window.location.assign(data.Instance);
        });
    }
}]);
